;------------------------------------------------------------- player constants		
	define	ini_indexed_mask 1
	define	ini_indexmask_size 32
	define	ini_relative 1
	define	ini_mus_loop 0

	define	ini_mus_stack #BE00
	define	mus_data_adr #C000
	define	max_inner_call 4
;------------------------------------------------------------- test code

;-------------------------------------------------------------- initialization
MUS_INIT
;------------------------------------------
	if ini_relative = 0
		;ld	(mus_init_adr),hl
	endif

	if ini_indexed_mask = 1

		ld	a,l
		ld	(index_adr_lo),a
		ld	a,h
		ld	(index_adr_hi),a

		ld	bc,ini_indexmask_size * 2
		add	hl,bc
	endif
		ld	(mus_adr),hl
	if ini_mus_loop = 1
		ld	(mus_adr_loop),hl
	endif
		ld	hl,ini_mus_stack
		ld	(mus_stack_adr),hl

	if ini_mus_loop = 0

;--------------------------------------------------------------
mus_stop
;------------------------------------------
					;  132 \ 115
		ld	c,#fd
		ld	h,#bf
		ld	de,#0d00
1		ld	b,c
		out	(c),d
		ld	b,h
		out	(c),e
		dec	d
		jp	p,1b
	endif
		ret
		
mus_stop_nop
	RET

;--------------------------------------------------------------
							;  23
muz_p		dec	a			;4
		ld	(mus_pause),a		;13

		ld	a,123-12
		dec	a
		jp	nz,$-1
		NOP:NOP				;1737
		
		
		ret				;10	/27
;-------------------------------------------------------------- music playback
MUS_PLAY	
;------------------------------------------
		ld	a,0			;7
mus_pause	  equ $-1
		or	a			;4
		jr	nz,muz_p		;7	12 18/23
		;currT = 18

;------------------- depack next command ------------------- ----- ---- --- -- - -  -   -   -    -
;11hhhhhh , llllllll , nnnnnnnn - call_n - play  N frames from mus_adr-00hhhhhh llllllll
;10hhhhhh , llllllll            - call_1 - play one frame from mus_adr-00hhhhhh llllllll
;01mmmmmm , mmmmmmmm ,  ......  - playback of psg2, where mmmmmm mmmmmmmm is a binary mask of AY-registers, then values
;001nnnnn                       - number of indexed mask in table (first 32 bytes of data block)
;0001pppp               - pause pppp+1 (1..16)
;0000hhhh , vvvvvvvv    - playback of psg1 (0000hhhh - register number + 1, vvvvvvvv - value)
;00001111               - end of playback (shutdown AY-chip or loop track)
;00000000 , nnnnnnnn    - wait for nnnnnnnn+1 frames (put nothing to registers)

		ld	hl,nolink		;10
		push	hl			;11
;commands
		ld	hl,#2121		;10
mus_adr		  equ $-2
		or	(hl)			;7
		inc	hl			;6
		jp	m,links			;10	;currT=72
		
		
		
		jr	z,do_pause_n		;7	12
	if ini_indexed_mask = 1					;<--- 79
		sub	64			;7
		jp	nc,do_01		;10
		sub	224			;7
		jp	nc,do_psg2_index	;10
		add	a,17			;7
		  if ini_mus_loop = 1				;<---  120
		     jr	z,mus_loop		;7	12
		  else
		     jr	z,mus_stop_nop		;-	--
		  endif
		;<---  127
		  
		jr	nc,do_psg1		;7	12
		dec	a			;4	;<---  138
	else
	;	cp	64			;7
	;	jp	nc,do_01		;10
	;	cp	15			;7
	;	  if ini_mus_loop = 1
	;	     jr	z,mus_loop		;7	12
	;	  else
	;	     jr	z,mus_stop		;7	12
	;	  endif						;---  110
	;	jr	c,do_psg1		;7	12
	;	and	15			;7
	endif
;-------------------------------------------------- ---- --- -- - -  -   -
;0001pppp - pause pppp+1 (1..16)
							;  138 \ 124
do_pause	ld	(mus_pause),a		;13
			if ini_indexed_mask = 1
				ld b,69		;7
				djnz $		;13*68+8=892
				dec de		;905
			else
			;	ld b,70		;7
			;	djnz $		;69*13+8 = 905+7 = 912
			endif
	
		jp	com_exit		;10		//161  1066 (905)

;-----------------------------------------------------------------------------------------
;0000hhhh , vvvvvvvv	- playback psg1 (0000hhhh - register number + 1, vvvvvvvv - value)
do_psg1
						;  139 \ 122
	if ini_indexed_mask = 1
		sub	#f2				;7
	else
	;	dec	a;4
	endif
		ld	bc,#fdfd	;10
		out	(c),a		;12
		ld	b,#bf		;7
		outi			;16 /62

	if ini_indexed_mask = 1
			ld b,65	  ;7
			djnz $	  ;13*64+8 = 840+7 = 847
			ld a,r:ld a,r ;18
	else
;			ld b,77	  ;7
;			djnz $	  ;13*76+8 = 996+7 = 1003
;			cp (hl)	  ;7

	endif
		jp	com_exit	;10	//201 (865)	// 181 (885)	  1066

;-----------------------------------------------------------
;00001111 - end of playback (shutdown AY-chip or loop track)

mus_loop					;  132 \ 115
	if ini_mus_loop = 1
		ld	hl,#2121	;10
mus_adr_loop	  equ $-2
		jp	mus_adr+2	;10
	endif
;---------------------------------------------------------------------------
;00000000 , nnnnnnnn - wait for nnnnnnnn+1 frames (put nothing to registers)

do_pause_n	rst 0				;  84
			ret	nz	;5
		ld	a,(hl)		;7
		inc	hl		;6
		ld	(mus_pause),a	;13
		
			ld b,73		;7
			djnz $		;13*72+8 = 944+7 = 951
		
		jp	com_exit	;10	/120	; 1076	(956)

;-----------------------------------------------------------------------------------------------------------
;01mmmmmm , mmmmmmmm - playback of psg2, where mmmmmm mmmmmmmm is a binary mask of AY-registers, then values

do_01						;  96 
		ex	af,af		;4
		ld	a,(hl)		;7
		inc	hl		;6
	if ini_indexed_mask = 1
		rld			;18
		rrd			;18
		nop:nop			;8
		jp	do_psg2_i	;10	//=71 /currT=167

;-------------------------------------------------------------------------
;001nnnnn - number of indexed mask in table (first 32 bytes of data block)

do_psg2_index						;  113
		add	a,a			;4

		add	a,0			;7
index_adr_lo	  equ $-1
		ld	e,a			;4
		adc	a,0			;7
index_adr_hi	  equ $-1
		sub	e			;4
		ld	d,a			;4
		ld	a,(de)			;7
		inc	de			;6

		ex	af,af			;4
		ld	a,(de)			;7
	endif					;	//=54
;__________________________________ _____ ____ ___ __ _ _  _   _    _
										;   167
do_psg2_i	ld	c,#fd		;7					--- 899 ---
		ld	de,#00bf	;10			+17

		   dup	8
		rra			;    4
		jr	nc,1F		;7	12
		ld	b,c		;4
		out	(c),d		;12
		ld	b,e		;4
		outi			;16
		jr	2F		;12
1		inc	(hl)		;	11
		dec	(hl)		;	11
		push	hl		;	11
		pop	hl		;	10
2		inc	d		;    4		//63/63	=504
		   edup

		ex	af,af		;    4			+4

		   dup	5
		rra			;    4
		jr	nc,1F		;7	12
		ld	b,c		;4
		out	(c),d		;12
		ld	b,e		;4
		outi			;16
		jr	2F		;12
1		inc	(hl)		;	11
		dec	(hl)		;	11
		push	hl		;	11
		pop	hl		;	10
2		inc	d		;    4		//55+8  =315
		   edup

		rra			;    4
		jr	nc,1F		;7	12
		ld	b,c		;4
		out	(c),d		;12
		ld	b,e		;4
		outi			;16
		jr	2F		;12
1		inc	(hl)		;	11
		dec	(hl)		;	11
		push	hl		;	11
		pop	hl		;	10
2	;	jp	com_exit	;   10		//55+4	=59 ////899

;-------------------------------------------------- ---- --- -- - -  -   -	c 1066
com_exit	
		ld	(mus_adr),hl		;16
		ld	a,(mus_stack_adr)	;13
		ld	hl,ini_mus_stack + 2	;10
		ld	b,0			;7

inner_calloop
  		inc	b			;4
		  cp	L			;4
		  jr	c,fuckret		;7	/ 12
		  dec	(hl)			;11
		  jp	z,mus_call_ret		;10
		  inc	L,L,L			;12
		  jp	inner_calloop		;10 // 58/36
mus_call_ret	
		dec	L			;4	;82 +  132 minimum, then + n (45*13=58)
		ld	d,(hl)			;7
		dec	L			;4
		ld	e,(hl)			;7
		ld	(mus_stack_adr),hl	;16
		ld	(mus_adr),de		;20 /58
		

		;w22
		LD HL,0:NOP:NOP:NOP
		;----		
		ld	a,4	;7
fuckret2	sub	b	;4
		ret	z
		
1		;---w44
		add hl,de	;11
		add hl,de	;11
		add hl,de	;11
		add hl,de	;11 /44
		;---
		dec	a	;4
		JP	NZ,1B	;10 /14
		ret				;10

fuckret							;66 +  74 minimum, then + n (45*13=58)
		
		;---
		;w28
		add hl,de	;11
		add hl,de	;11
		dec hl		;6
		;---
		LD A,5		;7
		JP	fuckret2;10 /30

;.........................................................................................

;----------------------------------------------------------- ----- ---- --- -- - -  -   -   -    -
;                  :

; PORT      MASK FOR 48k        MASK FOR 128k/+2       MASK FOR +2a/+2b/+3 
;#fe     xxxxxxxx xxxxxxx0      xxxxxxxx xxxxxxx0       xxxxxxxx xxxxxxx0
;#7ffd          n/a             0xxxxxxx xxxxxx0x       01xxxxxx xxxxxx0x
;#1ffd          n/a                    n/a              0001xxxx xxxxxx0x
;#bffd          n/a             10xxxxxx xxxxxx0x       10xxxxxx xxxxxx0x
;#fffd          n/a             11xxxxxx xxxxxx0       11xxxxxx xxxxxx0

;---------------------------------------------------------------------------------------
;11hhhhhh , llllllll , nnnnnnnn	- call_n - play  N frames from mus_adr-00hhhhhh llllllll
;10hhhhhh , llllllll		- call_1 - play one frame from mus_adr-00hhhhhh llllllll


;currT=72
links								;  +23					  72 	
		ld	c,(hl)		;7			;-- 163 --
		inc	hl		;6			; 186
		sub	%11000000	;7
		ld	b,a		;4
		jr	c,1f		;7 /12
		  ld	a,(hl)		;7
		  inc	hl		;6
		  jp	2f		;10
1		sub	%11000000	;   /7
		ld	b,a		;   /4
		ld	a,01		;   /7
2					;54/54


		ex	de,hl			;4
		pop	hl			;10
		ld	hl,#2121		;10
mus_stack_adr	  equ $-2
		ld	(hl),e			;7
		inc	L			;4
		ld	(hl),d			;7
		inc	L			;4
		ld	(hl),a			;7
		inc	L			;4
		ld	(mus_stack_adr),hl	;13
		xor	a			;4	;74

	if ini_relative = 1

		ex	de,hl		;4
		sbc	hl,bc		;15	CY is always = 0
		dec	de		;+6	
		jp	mus_adr + 2	;10	//35
		
	else
	;	ld	hl,#2121	;10
;mus_init_adr	  equ $-2
	;	add	hl,bc		;11
	;	nop			;+4	//35
	;	jp	mus_adr + 2	;10	;31
	endif
;__________________________________ _____ ____ ___ __ _ _  _   _    _
nolink	
		ld	b,12		;7
		djnz	$		;11*13+8=151
		ld a,r:ld a,r		;18
		ret			;10 /186
;---------------------------------------------------------------------------------------
